local MsgTag = "TestM"

local function OnLoad()
    CrossRP.Proto.SetMessageHandler(MsgTag, function(dest, msg, data)
        local actualMsg = string.sub(msg, string.find(msg, MsgTag) + MsgTag:len() + 1)
        print(actualMsg)
    end)

    local LWORadioMainFrame = CreateFrame("FRAME", "LWORadioMainFrame", UIParent, "BackdropTemplate")
    LWORadioMainFrame:SetPoint("CENTER", 0, 0)
    LWORadioMainFrame:SetSize(150, 45)
    LWORadioMainFrame:EnableMouse(true)
    LWORadioMainFrame:SetMovable(true)
    LWORadioMainFrame:RegisterForDrag("LeftButton")
    LWORadioMainFrame:SetScript("OnDragStart", LWORadioMainFrame.StartMoving)
    LWORadioMainFrame:SetScript("OnDragStop", LWORadioMainFrame.StopMovingOrSizing)
    LWORadioMainFrame:SetBackdrop({
        bgFile = "Interface/Tooltips/UI-Tooltip-Background",
        edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
        edgeSize = 12,
        insets = { left = 1, right = 1, top = 1, bottom = 1 },
    })
    LWORadioMainFrame:SetBackdropColor(0.5, 0.5, 0.5, 0.75)

    local senderName = UnitName("player")

    local LWORadioTestButton = CreateFrame("Button", "LWORadioTestButton", LWORadioMainFrame, "UIPanelButtonTemplate")
    LWORadioTestButton:SetSize(100, 25)
    LWORadioTestButton:SetPoint("CENTER", 0, 0)
    LWORadioTestButton:SetScript("OnClick", function()
        CrossRP.Proto.Send("all", {MsgTag, "This is a test message! Sender:", senderName})
    end )

    local LWORadioCloseButton = CreateFrame("Button", "LWORadioCloseButton", LWORadioMainFrame, "UIPanelCloseButton")
    LWORadioCloseButton:SetSize(20, 20)
    LWORadioCloseButton:SetPoint("TOPRIGHT", LWORadioMainFrame, "TOPRIGHT", 2, 2)
    LWORadioCloseButton:SetScript("OnClick", function() LWORadioMainFrame:Hide() end )
end

OnLoad()